		
; Peter Chrenko Wurmi 
; 2024 Hvezda Metra M4T demo in 2716/32 Eprom - Forver2024 edition
; I use 2732 eprom due easy programming
		ORG		0			; CPU 8080
		
CURSOR	EQU		41E0H
BITS	EQU		7
		
		LXI  	H,423FH
		SHLD 	CURSOR 	
		
		LXI		SP, 43FFH
		
		CALL	CLR
UP:		
	 
		MVI		B,BITS
		LXI		H,MSG
	 
UP3:	 	
		MVI		C,5
UP2:	 
		CALL	DISPLAY		; Z=1 IS RETURNED WHEN LAST CHAR
	 	
		JZ		END2			
		CALL	WAIT
		JMP		UP2
END2:
		DCR		C
		JZ		END3
		CALL	WAIT
		JMP		UP2
END3:	
		CALL	SCROLL
		DCR		B
		JNZ		UP3
		MVI		B,BITS
	 
		MOV		A,M
		INX		H
		ORA		A
	 
		JZ		UP			;? END OF STRING...
	 
		PUSH	H
		LXI		H, 413FH
		CALL	PRINT
		POP		H	
	 
		JMP		UP3	



WAIT:	 
		PUSH	PSW
		MVI  	A,026H
W1:   
		DCR  	A
		JNZ  	W1
		POP		PSW	
		RET	
	 
SCROLL:
		; HL TO LAST BYTE 
		PUSH	H
		PUSH	B
		LXI		H, 423FH
		LXI		D, 0780H 
			
LINE2:
		DCR		H
		MOV 	A,M
		RAR			; SET CY
		MOV		M,A
		INR		H
		
		MVI		B,8
LINE1:		
		
		MOV 	A,M
		JNC		$+4	; SKIP ORA IF CY=0
		ORA		E		
		RAR
		MOV		M,A
		DCR		L
		
		DCR		B
		JNZ		LINE1
		DCR		D
		JNZ		LINE2
		POP		B
		POP		H
		RET
			
		
		
	
DISPLAY:   
		PUSH	H
        PUSH	D
        PUSH 	B
         
        LHLD 	CURSOR
        MOV  	A,L
        RRC
        RRC
        RRC
        CMA
        INR  	A
        ORI  	20H
        MOV  	C,A
        LXI  	D,0BFFFH
CHAR1:  INX  	D
        MOV  	A,M
        ANI		1FH	; ONLY 5 BITS SHOW, BUT THERE ARE 3 BIT SPACES BETWEEN SEGMENTS
        STAX	D
        DCX  	H
        MOV  	A,E
        CPI  	07H
        JNZ  	CHAR1
        MOV  	A,C
        STA  	0000		; STROBE
        MOV  	A,L
        CPI  	07H		; END OF VRAM?
        JNZ  	SKIP1
        MVI  	L,3FH		; HL=423FH
SKIP1:  SHLD 	CURSOR
         ; Z=1 WHEN LAST CHAR PRINTED, Z=0 OTHER
		POP  	B
        POP  	D
        POP  	H
        RET

CLR:	
		LXI		H, 423FH
CLR1:	MVI		M,0
		DCR		L
		JNZ		CLR1	
		MVI		M,0
	 
		MVI		A,' '
		LXI		H, 413FH
		CALL	PRINT
		RET
	          
         
PRINT:	;A = ASCII
		; HL = ADRESA KURZORA V VIDEOPAMATI         
		PUSH B           ; UKLIDIT REGISTRY
		PUSH H
               
        SUI  20H		; START TABLE	- FROM SPACE
     	ADD  A
     	ADD  A
     	ADC  A		; A=A*8, CY BIT
     	MOV  C,A
     	MVI  A, (CHARTABLE)/256
     	ACI  0								
     	MOV  B,A		 
PRT_CYCLE:       
        LDAX B           ; BYTE Z TABULKY ZNAKU
		INX  B           ; DALSI BYTE TABULKY
		MOV  M, A        ; A ULOZIT DO V-RAM
		MOV  A,L
		SUI  08H	
		MOV  L,A	 ; ADRESA DALÍHO BYTU VE V-RAM
		CPI  08H	 ; JE VIAC AKO 08H ? TAK CYKLI
		JNC  PRT_CYCLE      
		POP  H           ; HOTOVO, OBNOV HL 
		POP  B
		RET
		
		ORG 100H
CHARTABLE:	 	
     DB   00H, 00H, 00H, 00H ; SPC
     DB   00H, 00H, 00H, 00H
     DB   04H, 04H, 04H, 04H ; !
     DB   04H, 00H, 04H, 00H
     DB   0AH, 0AH, 00H, 00H ; "
     DB   00H, 00H, 00H, 00H
     DB   0AH, 0AH, 1FH, 0AH ; #
     DB   1FH, 0AH, 0AH, 00H
     DB   0EH, 15H, 15H, 0EH ; $
     DB   14H, 15H, 0EH, 00H
     DB   03H, 13H, 08H, 04H ; %
     DB   02H, 19H, 18H, 00H
     DB   04H, 0AH, 0AH, 06H ; &
     DB   15H, 09H, 16H, 00H
     DB   04H, 04H, 02H, 00H ; '
     DB   00H, 00H, 00H, 00H
     DB   08H, 04H, 02H, 02H ; (
     DB   02H, 04H, 08H, 00H
     DB   02H, 04H, 08H, 08H ; )
     DB   08H, 04H, 02H, 00H
     DB   00H, 04H, 15H, 0EH ; *
     DB   15H, 04H, 00H, 00H
     DB   00H, 04H, 04H, 1FH ; +
     DB   04H, 04H, 00H, 00H
     DB   00H, 00H, 00H, 00H ; ,
     DB   02H, 02H, 01H, 00H
     DB   00H, 00H, 00H, 1FH ; -
     DB   00H, 00H, 00H, 00H
     DB   00H, 00H, 00H, 00H ; .
     DB   00H, 00H, 02H, 00H
     DB   00H, 10H, 08H, 04H ; /
     DB   02H, 01H, 00H, 00H
     DB   0EH, 11H, 19H, 15H ; 0
     DB   13H, 11H, 0EH, 00H
     DB   04H, 06H, 04H, 04H ; 1
     DB   04H, 04H, 0EH, 00H
     DB   0EH, 11H, 10H, 0CH ; 2
     DB   02H, 01H, 1FH, 00H
     DB   1FH, 10H, 08H, 1CH ; 3
     DB   10H, 11H, 0EH, 00H
     DB   08H, 0CH, 0AH, 09H ; 4
     DB   1FH, 08H, 08H, 00H
     DB   1FH, 01H, 0FH, 10H ; 5
     DB   10H, 11H, 0EH, 00H
     DB   1CH, 02H, 01H, 0FH ; 6
     DB   11H, 11H, 0EH, 00H
     DB   1FH, 10H, 08H, 04H ; 7
     DB   02H, 02H, 02H, 00H
     DB   0EH, 11H, 11H, 0EH ; 8
     DB   11H, 11H, 0EH, 00H
     DB   0EH, 11H, 11H, 1EH ; 9
     DB   10H, 08H, 07H, 00H
     DB   00H, 00H, 00H, 00H ; :
     DB   02H, 00H, 02H, 00H
     DB   00H, 00H, 04H, 00H ; ;
     DB   04H, 04H, 02H, 00H
     DB   08H, 04H, 02H, 01H ; <
     DB   02H, 04H, 08H, 00H
     DB   00H, 00H, 1FH, 00H ; =
     DB   1FH, 00H, 00H, 00H
     DB   02H, 04H, 08H, 10H ; >
     DB   08H, 04H, 02H, 00H
     DB   0EH, 11H, 10H, 08H ; ?
     DB   04H, 00H, 04H, 00H
     DB   06H, 11H, 19H, 15H ; @
     DB   1DH, 01H, 0EH, 00H
     DB   04H, 0AH, 11H, 11H ; A
     DB   1FH, 11H, 11H, 00H
     DB   0FH, 11H, 11H, 0FH ; B
     DB   11H, 11H, 0FH, 00H
     DB   0EH, 11H, 01H, 01H ; C
     DB   01H, 11H, 0EH, 00H
     DB   0FH, 12H, 12H, 12H ; D
     DB   12H, 12H, 0FH, 00H
     DB   1FH, 01H, 01H, 0FH ; E
     DB   01H, 01H, 1FH, 00H
     DB   1FH, 01H, 01H, 0FH ; F
     DB   01H, 01H, 01H, 00H
     DB   0EH, 11H, 01H, 01H ; G
     DB   19H, 11H, 1EH, 00H
     DB   11H, 11H, 11H, 1FH ; H
     DB   11H, 11H, 11H, 00H
     DB   0EH, 04H, 04H, 04H ; I
     DB   04H, 04H, 0EH, 00H
     DB   10H, 10H, 10H, 10H ; J
     DB   11H, 11H, 0EH, 00H
     DB   11H, 09H, 05H, 03H ; K
     DB   05H, 09H, 11H, 00H
     DB   01H, 01H, 01H, 01H ; L
     DB   01H, 01H, 0FH, 00H
     DB   11H, 1BH, 15H, 15H ; M
     DB   11H, 11H, 11H, 00H
     DB   11H, 11H, 13H, 15H ; N
     DB   19H, 11H, 11H, 00H
     DB   0EH, 11H, 11H, 11H ; O
     DB   11H, 11H, 0EH, 00H
     DB   0FH, 11H, 11H, 0FH ; P
     DB   01H, 01H, 01H, 00H
     DB   0EH, 11H, 11H, 11H ; Q
     DB   15H, 09H, 16H, 00H
     DB   0FH, 11H, 11H, 0FH ; R
     DB   05H, 09H, 11H, 00H
     DB   0EH, 11H, 01H, 0EH ; S
     DB   10H, 11H, 0EH, 00H
     DB   1FH, 04H, 04H, 04H ; T
     DB   04H, 04H, 04H, 00H
     DB   11H, 11H, 11H, 11H ; U
     DB   11H, 11H, 0EH, 00H
     DB   11H, 11H, 11H, 0AH ; V
     DB   0AH, 04H, 04H, 00H
     DB   11H, 11H, 11H, 15H ; W
     DB   15H, 15H, 0AH, 00H
     DB   11H, 11H, 0AH, 04H ; X
     DB   0AH, 11H, 11H, 00H
     DB   11H, 11H, 0AH, 04H ; Y
     DB   04H, 04H, 04H, 00H
     DB   1FH, 10H, 08H, 04H ; Z
     DB   02H, 01H, 1FH, 00H
     DB   07H, 01H, 01H, 01H ; [
     DB   01H, 01H, 07H, 00H
     DB   00H, 01H, 02H, 04H ; \
     DB   08H, 10H, 00H, 00H
     DB   1CH, 10H, 10H, 10H ; ]
     DB   10H, 10H, 1CH, 00H
     DB   0EH, 11H, 00H, 00H ; ^
     DB   00H, 00H, 00H, 00H
     DB   00H, 00H, 00H, 00H ; _
     DB   00H, 00H, 1FH, 00H
     
MSG: 
		
		DB 	" *** HELLO WORLD, THIS IS A NEW DEMO FOR HVEZDA METRA M4T TERMINAL FROM 1980 YEAR *** "
		DB  "   ... FORVER MARCH 2024, SUCHA NAD PARNOU, SLOVAKIA ... "
		DB  "   *** HAPPY BIRTHDAY INTEL 8080 (EIGHTY-EIGHTY). NICE 50 YEARS OF DUTY AND STILL IN USE *** "
		DB	"   *** IN 1974 INTEL RELEASED 8-BIT MICROPROCESSOR 8080, THE FIRST TRULY USABLE MICROPROCESSOR.  *** "
		DB  "   @@@ THE 8080 WAS DESIGNED BY FEDERICO FAGGIN AND MASATOSHI SHIMA. THE WORK ON 8080 MICROPROCESSOR WAS STARTED AT THE END OF 1972, AND THE CPU WAS RELEASED IN APRIL OF 1974.  @@@ "
		DB	"   ==> GERET METRA M4T HAS 2KBYTES EPROM, 1 KBYTES RAM, MATRIX DISPLAY 2*VQC10, FONT 5*7 FROM PMD-85/1.0  <==   " 	
		DB	"   ... CHIP 8228 IS MISSING, M4T IS EARLY DESIGN WITHOUT HOLY TRINITY 8080+8228+8224   " 	
		DB  "   ### MANY GREETINGS TO CLONES MHB8080, KR580VM80A, AM9080A, KR580IK80A, M5L8080AP, M58710P, INS8080AD, D8080A, NTE8080A, MSM8080A, MCY7880, SAB8080A, MP8080AI, TMS8080JL, TMP9080AP, AND NEXT-GEN 8085, 8048, 8051, Z-80 CPU. ### " 
		DB "       "
		DB	0
		
    
